package com.sun.xml.internal.ws.assembler.dev;

import com.sun.xml.internal.ws.api.model.wsdl.WSDLPort;
import com.sun.xml.internal.ws.api.pipe.ServerTubeAssemblerContext;
import com.sun.xml.internal.ws.api.pipe.Tube;
import com.sun.istack.internal.Nullable;
import com.sun.xml.internal.ws.api.model.SEIModel;
import com.sun.xml.internal.ws.policy.PolicyMap;
import com.sun.xml.internal.ws.api.server.WSEndpoint;
import com.sun.istack.internal.NotNull;
import com.sun.xml.internal.ws.api.pipe.Codec;

public interface ServerTubelineAssemblyContext extends TubelineAssemblyContext
{
    @NotNull
    public abstract Codec getCodec();
    
    @NotNull
    public abstract WSEndpoint getEndpoint();
    
    public abstract PolicyMap getPolicyMap();
    
    @Nullable
    public abstract SEIModel getSEIModel();
    
    @NotNull
    public abstract Tube getTerminalTube();
    
    public abstract ServerTubeAssemblerContext getWrappedContext();
    
    @Nullable
    public abstract WSDLPort getWsdlPort();
    
    public abstract boolean isPolicyAvailable();
    
    public abstract boolean isSynchronous();
    
    public abstract void setCodec(@NotNull Codec p0);
}
